#include <string.h>
#include <iostream.h>

class bnode {
public:
  bnode(int d, bnode* l, bnode* r) { data = d; left = l; rite = r;}
protected:
  bnode* left;
  bnode* rite;    
  int data; // The data value stored in a node.
  int comp(int x, int y) { return ( x - y ); } //Compares node value against input
};

class bstree : public bnode {
public:
  void insert(int);
  void find(int);
  bstree(int d): bnode(d, 0, 0) {} // Calls base class constructor with input
};

void bstree::insert(int d) {
  bstree* templ = (bstree *) left;
  bstree* tempr = (bstree *) rite;

  if (comp(data, d) > 0) {
    if(templ)
      templ->insert(d);
    else
      left = (bstree*) new bstree(d);
  }
  else
    if (comp(data, d) < 0) {
      if(tempr)
	tempr->insert(d);
      else
	rite = (bstree*) new bstree(d);
    }
}


void bstree::find(int d) {
  bstree* templ = (bstree *) left;
  bstree* tempr = (bstree *) rite;
  if (comp(data, d) == 0) {  // Found!
    cout << "In Tree\n";
    return;
  }
  else
    if (comp(data, d) > 0) {
      if(templ)
	templ->find(d);
      else
	cout << "Not in tree\n";
    }
    else
      {
      if(tempr)
	tempr->find(d);
      else
	cout << "Not in tree\n";
    }	   
}

void main(void) {
int input;
  cout << "Construct Tree:\n";  // Construction phase
  cin >> input;
  bstree st_root(input);
  while(input != 9999) { // 9999 is the signal to stop
    cin >> input;
    st_root.insert(input);
  }
  cout << "Check Tree:\n";  // Check phase
  cin >> input;
  while(input != 9999) { // 9999 is the signal to stop
    st_root.find(input);
    cin >> input;
  }
}
